# THIS WORK CONTAINS TRADE SECRET AND CONFIDENTIAL
# INFORMATION WHICH ARE THE PROPERTY OF SIEMENS INDUSTRY
# SOFTWARE INC OR ITS LICENSORS OR AFFILIATES AND IS
# SUBJECT TO LICENSE TERMS.
# VERSION 2403

from xml.dom import minidom
import os
import tempfile
import time
import psutil


def fsplay(fsPath, fltBin, silent=True):
    if '"' in fltBin:
        fsCMD = fltBin + r'\flotherm.bat'
    else:
        fsCMD = '"' + fltBin + r'"\flotherm.bat'
    if silent: fsCMD = fsCMD + ' -b'
    fsCMD = fsCMD + ' -f ' + r'\"' + fsPath + r'\"'
    os.system('call ' + fsCMD)


def fsplaySubProcess(fsPaths, flosuitepath, verbose=True):
    import subprocess
    runThese = []
    runThese = [[flosuitepath + r'\flotherm\WinXP\bin\flotherm.bat', '-b', '-f', '"' + f + '"'] for f in fsPaths]
    # for f in fsPaths:
    #     runThese.append(
    #         [flosuitepath + r'\flotherm\WinXP\bin\flotherm.bat', '-b', '-f', '"' + f + '"'] for f in fsPaths)
    procs, ls = [], []
    for i, runThis in enumerate(runThese):
        if verbose: print('started ' + str(i + 1) + ' of ' + str(len(runThese)) + '... ' + os.path.basename(fsPaths[i]))
        procs.append(subprocess.Popen(runThis))
        time.sleep(5)
        ls.append(psutil.Process(procs[i].pid))
    gone, alive = psutil.wait_procs(ls, timeout=None)


def newfs():
    fsStr = r'<xml_log_file version="1.0"></xml_log_file>'
    fsXML = minidom.parseString(fsStr)
    return fsXML


def savefs(fsXML, fsPath):
    #  THE ONLY METHOD I HAVE FOUND TO CONFIDENTLY NOT HAVE MULTIPLE EMPTY LINES
    tmpPath = tempfile.NamedTemporaryFile().name
    xml_str = fsXML.toprettyxml(indent="\t", newl="\n", encoding="utf-8")
    with open(tmpPath, "wb") as f:
        f.write(xml_str)
    with open(tmpPath, 'r') as fs:
        fsLines = fs.read().splitlines()
    fsOut = open(fsPath, 'w')
    for fsLine in fsLines:
        if len(fsLine) > 0: fsOut.write(fsLine + '\n')
    fsOut.close()
    os.remove(tmpPath)


def start(fsXML, reInit=False):
    #     reinitialiseSolve ,solver
    strt = 'solver'
    if reInit: strt = 'reinitialiseSolve'
    fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('start')).setAttribute('start_type',
                                                                                                         strt)
    # <question answer="yes" text="deleteSolutionData?" />
    if reInit:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('question'))
        node.setAttribute('answer', 'yes')
        node.setAttribute('text', 'deleteSolutionData?')

    fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('solve_idle_event'))


def assembly_importToRoot(fsXML, filename, import_type='FloXML'):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('assembly_import'))
    node.setAttribute('filename', filename)
    node.setAttribute('import_type', import_type)
    node = node.appendChild(fsXML.createElement('geometry_name')).appendChild(fsXML.createElement('geometry'))
    node.setAttribute('name', 'Root Assembly')


def change_solution_directory(fsXML, directory_path):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('change_solution_directory'))
    node.setAttribute('directory_path', directory_path)


def wait(fsXML, delay):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('wait'))
    node.setAttribute('delay', str(delay))


def project_load(fsXML, project_name, unlock=True):
    if unlock:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('project_unlock'))
        node.setAttribute('project_name', project_name)
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('project_load'))
    node.setAttribute('project_name', project_name)


def quitft(fsXML):
    fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('quit'))


def project_save(fsXML):
    fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('project_save'))


def project_new(fsXML, template_name, project_category='My Defaults'):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('project_new'))
    node.setAttribute('project_category', project_category)
    node.setAttribute('project_name', template_name)


def project_save_as(fsXML, project_name, save_with_results=False):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('question'))
    node.setAttribute('answer', 'yes')
    node.setAttribute('text', 'projectExists%1Overwrite?')
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('project_save_as'))
    node.setAttribute('project_name', project_name)
    node.setAttribute('save_with_results', str(save_with_results).lower())


def change_results_mode(fsXML, is_results_mode=True):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('change_results_mode'))
    node.setAttribute('is_results_mode', str(is_results_mode).lower())


def find_cycle_select(fsXML, isNext=True):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('find_cycle_select'))
    if isNext:
        node.setAttribute('direction', 'next')
    else:
        node.setAttribute('direction', 'previous')


def deleteAfterFind(fsXML):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('delete_geometry'))


def find(fsXML, geometryName='', geometryType='', partialMatch=False, isCycleSelect=False, searchFromCurrent=False,
         isAttr=False):
    # geometry Name and type are used for attributes if isAttr==True
    selectMode, searchMode = 'all', 'model'
    if searchFromCurrent: searchMode = 'current_selection'
    if isCycleSelect: selectMode = 'cycle'
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('find'))
    node.setAttribute('filter', 'false')
    node.setAttribute('match', 'all')
    node.setAttribute('search_mode', searchMode)
    node.setAttribute('select_mode', selectMode)
    if isAttr:
        node.setAttribute('select_nodes', 'attributes')
    else:
        node.setAttribute('select_nodes', 'geometry')
    if len(geometryName) > 0:
        strNode = node.appendChild(fsXML.createElement('string_query_constraint'))
        strNode.setAttribute('case_sensitive', 'false')
        strNode.setAttribute('criteria_type', 'common')
        strNode.setAttribute('partial_match', str(partialMatch).lower())
        valNode = strNode.appendChild(fsXML.createElement('value'))
        valNode.setAttribute('property_name', 'name')
        valNode.setAttribute('value', geometryName)
    if len(geometryType) > 0:
        eNode = node.appendChild(fsXML.createElement('enum_query_constraint'))
        eNode.setAttribute('criteria_type', 'common')
        eNode.setAttribute('is_positive', 'true')
        valNode = eNode.appendChild(fsXML.createElement('value'))
        if isAttr:
            valNode.setAttribute('property_name', 'attributeType')
        else:
            valNode.setAttribute('property_name', 'geometryType')
        valNode.setAttribute('value', geometryType)


def modifyAfterFind(fsXML, new_value, property_name):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('modify_geometry'))
    node.setAttribute('new_value', str(new_value))
    node.setAttribute('property_name', property_name)


def modify_attribute(fsXML, attrNm, attrType, new_value, property_name, group_name):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('modify_attribute'))
    node.setAttribute('group_name', group_name)
    node.setAttribute('new_value', str(new_value))
    node.setAttribute('property_name', property_name)
    node = node.appendChild(fsXML.createElement('attribute_name'))
    node.setAttribute('name', attrNm)
    node.setAttribute('type', attrType)


def curve_modify_attribute(fsXML, attrNm, attrType, property_name, xUnit, yUnit, curvePoints):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('curve_modify_attribute'))
    node.setAttribute('property_name', property_name)
    node.setAttribute('x_unit', xUnit)
    node.setAttribute('y_unit', yUnit)
    aNode = node.appendChild(fsXML.createElement('attribute_name'))
    aNode.setAttribute('name', attrNm)
    aNode.setAttribute('type', attrType)
    for c in curvePoints:
        cNode = node.appendChild(fsXML.createElement('curve_point'))
        cNode.setAttribute('x', str(c[0]))
        cNode.setAttribute('y', str(c[1]))


def projecExport(fsXML, export_type, filename):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('project_export'))
    node.setAttribute('export_type', export_type)
    node.setAttribute('filename', filename)
    if export_type in ['Thermal Netlist', 'BCI-ROM']:
        fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('solve_idle_event'))


def export_all_tables(fsXML, filename):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('export_all_tables'))
    node.setAttribute('filename', filename)


def export_transient_table(fsXML, filename, table_id='monitorPoints'):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('export_transient_table'))
    node.setAttribute('filename', filename)
    node.appendChild(fsXML.createElement('table_id')).setAttribute('name', table_id)


def export_table(fsXML, filename, table_id):
    # table_id examples: solidConductorsSummary,solidConductorTemperatures,solidConductorFluxes
    if table_id[:5] == 'solid':
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(
            fsXML.createElement('tables_smartpart_details'))
        node.setAttribute('is_enabled', 'true')
        node = node.appendChild(fsXML.createElement('table_id'))
        node.setAttribute('name', table_id)
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('export_table'))
    node.setAttribute('filename', filename)
    node = node.appendChild(fsXML.createElement('table_id'))
    node.setAttribute('name', table_id)


def export_legacy_tables(fsXML, directory, attributes=False, geometry_model=False, grid=False, results=False):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('change_results_mode'))
    node.setAttribute('is_results_mode', 'true')
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('export_legacy_tables'))
    node.setAttribute('directory', directory)
    node.setAttribute('attributes', str(attributes).lower())
    node.setAttribute('geometry_model', str(geometry_model).lower())
    node.setAttribute('grid', str(grid).lower())
    node.setAttribute('results', str(results).lower())


def results_state_reinitialize(fsXML):
    fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('results_state_reinitialize'))


def viewport_standard_view(fsXML, direction, minusDir=False):
    # direction:x,y,z
    # minusDir: True, False
    # Z Minus, Z Plus (X,Y)

    if direction.capitalize() not in ['X', 'Y', 'Z']: direction = 'X'
    if minusDir:
        strDir = direction.capitalize() + ' Minus'
    else:
        strDir = direction.capitalize() + ' Plus'

    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('viewport_standard_view'))
    node.setAttribute('standard_view', strDir)
    node.setAttribute('viewport_name', 'Top Left')


def viewport_output_snapshot(fsXML, filename):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('viewport_output_snapshot'))
    node.setAttribute('file_type', 'png')
    node.setAttribute('filename', filename)
    node.setAttribute('viewport_name', 'Top Left')


def jump_to_viewpoint(fsXML, viewpointNm):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('jump_to_viewpoint'))
    node.setAttribute('name', viewpointNm)
    node.setAttribute('type', 'viewpoint')


def create_results_plot(fsXML, rootAssyNm, pip):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('create_results_plot'))
    node.setAttribute('plot_type', 'surfacePlot')
    node.appendChild(_geomNdTreeFromPiP(fsXML, rootAssyNm, pip))


def select_geometry(fsXML, rootAssyNm, pip):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('select_geometry'))
    node.appendChild(_geomNdTreeFromPiP(fsXML, rootAssyNm, pip, selected=True))


def top_geometry(fsXML, rootAssyNm, pip):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('top_geometry'))
    node.appendChild(_geomNdTreeFromPiP(fsXML, rootAssyNm, pip))


def expand_geometry(fsXML, rootAssyNm, pip):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('expand_geometry'))
    node.appendChild(_geomNdTreeFromPiP(fsXML, rootAssyNm, pip))


def reset_geometry(fsXML):
    fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('reset_geometry'))


def modify_results_node(fsXML, scalar='Temperature', autoRange=True, legendMin=0, legendMax=0):
    if autoRange:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('modify_results_node'))
        node.setAttribute('new_value', 'autoRange')
        node.setAttribute('property_name', 'range')
        rnode = node.appendChild(fsXML.createElement('results_node_name'))
        rnode.setAttribute('name', scalar)
        rnode.setAttribute('type', 'scalarFields')
    elif legendMax > legendMin:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('modify_results_node'))
        node.setAttribute('new_value', str(legendMin))
        node.setAttribute('property_name', 'legendMinimumValue')
        rnode = node.appendChild(fsXML.createElement('results_node_name'))
        rnode.setAttribute('name', scalar)
        rnode.setAttribute('type', 'scalarFields')

        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('modify_results_node'))
        node.setAttribute('new_value', str(legendMax))
        node.setAttribute('property_name', 'legendMaximumValue')
        rnode = node.appendChild(fsXML.createElement('results_node_name'))
        rnode.setAttribute('name', scalar)
        rnode.setAttribute('type', 'scalarFields')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('modify_results_node'))
        node.setAttribute('new_value', 'totalRange')
        node.setAttribute('property_name', 'range')
        rnode = node.appendChild(fsXML.createElement('results_node_name'))
        rnode.setAttribute('name', scalar)
        rnode.setAttribute('type', 'scalarFields')


def modify_bcirom_user_preferences(fsXML, error=0.01, minHTC=1, maxHTC=10000):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('modify_bci_rom_preferences'))
    gnode = node.appendChild(fsXML.createElement('new_value'))
    gnode.setAttribute('new_value', str(error))
    gnode.setAttribute('property_name', 'acceptableRelativeError')
    gnode.setAttribute('new_value', str(minHTC))
    gnode.setAttribute('property_name', 'minHtc')
    gnode.setAttribute('new_value', str(maxHTC))
    gnode.setAttribute('property_name', 'maxHtc')


def modify_user_preferences(fsXML, showtitle=False, backgroundWhite=True, useScreenResolution=False, snapshotWidth=1920,
                            snapshotHeight=1080):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('modify_user_preferences'))
    gnode = node.appendChild(fsXML.createElement('new_value'))
    gnode.setAttribute('new_value', str(showtitle).lower())
    gnode.setAttribute('property_name', 'showTitle')
    if useScreenResolution:
        gnode = node.appendChild(fsXML.createElement('new_value'))
        gnode.setAttribute('new_value', 'true')
        gnode.setAttribute('property_name', 'outputSnapshotUseScreenResolution')
    else:
        gnode = node.appendChild(fsXML.createElement('new_value'))
        gnode.setAttribute('new_value', 'false')
        gnode.setAttribute('property_name', 'outputSnapshotUseScreenResolution')
        gnode = node.appendChild(fsXML.createElement('new_value'))
        gnode.setAttribute('new_value', str(snapshotWidth))
        gnode.setAttribute('property_name', 'snapshotWidth')
        gnode = node.appendChild(fsXML.createElement('new_value'))
        gnode.setAttribute('new_value', str(snapshotHeight))
        gnode.setAttribute('property_name', 'snapshotHeight')

    if backgroundWhite:
        gnode = node.appendChild(fsXML.createElement('new_value'))
        gnode.setAttribute('group_name', 'analyze')
        gnode.setAttribute('new_value', 'false')
        gnode.setAttribute('property_name', 'gradientBackground')
        gnode = node.appendChild(fsXML.createElement('new_value'))
        gnode.setAttribute('group_name', 'analyze')
        gnode.setAttribute('new_value', '1 1 1')
        gnode.setAttribute('property_name', 'backgroundColor')


def _geomNdTreeFromPiP(fsXML, rootAssyNm, geomPiP, selected=False):
    if selected:
        gnode = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('selected_geometry_name'))
    else:
        gnode = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('geometry_name'))
    node = gnode.appendChild(fsXML.createElement('geometry'))
    node.setAttribute('name', rootAssyNm)
    for p in geomPiP:  # FIRST INDEX IS ROOT ASSEMBLY, SKIP
        node = node.appendChild(fsXML.createElement('geometry'))
        node.setAttribute('position_in_parent', str(p))
    return gnode


def getPiPsFromGeom(geomCSV):
    # FROM SIMCENTER FLOTHERM LEGACY GEOMETRY MODEL CSV
    # RETURNS: [OBJECT NAME, OBJECT TYPE, STRING '|': ASSEMBLY PATH, LIST:[POSITION IN PARENT]]
    pips = []
    quotechar = '"'
    with open(geomCSV, 'r') as myGeom:
        gLines = myGeom.read().splitlines()  # READFILE
    geomData = []

    for g in gLines[1:]:
        if len(g) > 0 and g[0:6] != 'TOTALS':
            geom = g.split(',')
            if quotechar in g:
                frstSplit = g.split(quotechar)
                gNm = frstSplit[1]
                theRest = frstSplit[2][1:]
                geom = theRest.split(',')
                geom.insert(0, gNm)
            # NAME, TYPE, LEVEL
            geomData.append([geom[0], geom[1], int(geom[2])])

    ndPath = [geomData[0][0]]
    ndLvl = geomData[0][2]
    ndLvlOld = ndLvl
    pipPath = [0]
    for nd in geomData[1:]:
        ndNm = nd[0]
        ndType = nd[1]
        ndLvl = nd[2]
        if ndLvl == ndLvlOld:  # SIBLING
            ndPath = ndPath[:-1]
            ndPath.append(ndNm)
            pipPath[-1] += 1
        elif ndLvl > ndLvlOld:  # CHILD
            ndPath.append(ndNm)
            pipPath.append(0)
        else:  # ANCESTOR
            ndDiff = len(ndPath) - ndLvl
            ndPath = ndPath[:-ndDiff]
            ndPath.append(ndNm)
            pipPath = pipPath[:-ndDiff + 1]
            pipPath[-1] += 1
        pips.append([ndNm, ndType, '|'.join(ndPath), [p for p in pipPath]])
        ndLvlOld = ndLvl
    return pips


def getFloSolnDir(floSuite):
    # floSuite = r'C:\Program Files\MentorMA\flosuite_v2020.2'
    cfgFldr = os.path.join(floSuite, r'flotherm\config')
    userNm = os.environ['username']
    flocfg = [f for f in os.listdir(cfgFldr) if
              f[-3:] == 'cfg' and os.path.splitext(f)[0][-1].isnumeric() and f[:len(userNm)] == userNm][0]
    with open(os.path.join(cfgFldr, flocfg), 'r') as myconfig:
        cfgLines = myconfig.read().splitlines()  # READFILE

    return [l.strip().split(' ')[2] for l in cfgLines if 'DataDirectory' in l][0]


def promote(fsXML, assyNm, rootNm='Root Assembly'):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('promote_geometry'))
    gnode = node.appendChild(fsXML.createElement('geometry_name')).appendChild(fsXML.createElement('geometry'))
    gnode.setAttribute('name', rootNm)
    gnode = gnode.appendChild(fsXML.createElement('geometry'))
    gnode.setAttribute('name', assyNm)


def deleteLevelZero(fsXML, PiP=0, rootNm='Root Assembly'):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('delete_geometry'))
    gnode = node.appendChild(fsXML.createElement('geometry_name')).appendChild(fsXML.createElement('geometry'))
    gnode.setAttribute('name', rootNm)
    gnode = gnode.appendChild(fsXML.createElement('geometry'))
    gnode.setAttribute('position_in_parent', str(PiP))


def createAfterFind(fsXML, geometryType='cutout', deleteSelection=False):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('create_geometry'))
    node.setAttribute('geometry_type', geometryType)
    if deleteSelection:
        fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('delete_geometry'))


def launch(fsXML, launchType='mcad'):
    # drawingBoard, eda, mcad, profiles, tables, visualEditior
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('launch'))
    node.setAttribute('launch_type', launchType)


def import_odb(fsXML, odbPath, transferToflt=True, asExternal=True):
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'EDA')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    node = node.appendChild(fsXML.createElement('import_odb'))
    node.setAttribute('filename', odbPath)


def edaTransfer(fsXML):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
    node.setAttribute('process', 'EDA')
    node.appendChild(fsXML.createElement('transfer'))


def filterEDA(fsXML, side_length_less_than, height_less_than, power_less_than, power_density_less_than,
              ref_des_contains='r,q', combine_parameters_by='or', delete_filtered=True, asExternal=True):
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'EDA')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    node = node.appendChild(fsXML.createElement('filter_components'))
    vals = [combine_parameters_by, side_length_less_than, height_less_than, power_less_than, power_density_less_than,
            ref_des_contains, str(delete_filtered).lower()]
    props = ['combine_parameters_by', 'side_length_less_than', 'height_less_than', 'power_less_than',
             'power_density_less_than', 'ref_des_contains', 'delete_filtered']
    for i, v in enumerate(vals):
        vNd = node.appendChild(fsXML.createElement('new_value'))
        vNd.setAttribute('new_value', str(v))
        vNd.setAttribute('property_name', props[i])


def mcadImportProject(fsXML, asExternal=True):
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'MCAD')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    node.appendChild(fsXML.createElement('import_project_geometry'))


def mcadExport(fsXML, filePath, asExternal=True, export_type='Step'):
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'MCAD')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    node = node.appendChild(fsXML.createElement('export'))
    node.setAttribute('export_type', export_type)
    node.setAttribute('filename', filePath)


def mcadVoxelize(fsXML, asExternal=True, minimumCellSize=1e-5):
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'MCAD')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    node = node.appendChild(fsXML.createElement('voxelize'))
    nnode = node.appendChild(fsXML.createElement('new_value'))
    nnode.setAttribute('new_value', 'm')
    nnode.setAttribute('property_name', 'lengthUnit')
    nnode = node.appendChild(fsXML.createElement('new_value'))
    nnode.setAttribute('new_value', str(minimumCellSize))
    nnode.setAttribute('property_name', 'minimumCellSize')


def mcadImport(fsXML, filePath, asExternal=True, import_type='Step'):
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'MCAD')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    node = node.appendChild(fsXML.createElement('import'))
    node.setAttribute('import_type', import_type)
    node.setAttribute('filename', filePath)


def mcadPowerSelectAll(fsXML, asExternal=True):
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'MCAD')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    node = node.appendChild(fsXML.createElement('power_select'))
    nnode = node.appendChild(fsXML.createElement('new_value'))
    nnode.setAttribute('new_value', 'm^3')
    nnode.setAttribute('property_name', 'volumeUnit')
    nnode = node.appendChild(fsXML.createElement('new_value'))
    nnode.setAttribute('new_value', '1')
    nnode.setAttribute('property_name', 'volume')

    nnode = node.appendChild(fsXML.createElement('new_value'))
    nnode.setAttribute('new_value', 'lessThanEqualVolume')
    nnode.setAttribute('property_name', 'bodiesAction')


def mcadUnite(fsXML, asExternal=True, nAssumedBodies=100, skipFirstBody=False, isAfter2210=False):
    loopStrt = 0
    if skipFirstBody: loopStrt = 1
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'MCAD')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    unode = node.appendChild(fsXML.createElement('unite_bodies'))
    if not isAfter2210:
        for i in range(loopStrt, nAssumedBodies):
            gnode = unode.appendChild(fsXML.createElement('geometry_name')).appendChild(
                fsXML.createElement('geometry')).appendChild(fsXML.createElement('geometry'))
            gnode.setAttribute('position_in_parent', str(i))
            gnode = gnode.appendChild(fsXML.createElement('geometry'))
            gnode.setAttribute('position_in_parent', '0')


def mcadSubtract(fsXML, PiPFirst=0, PiPSecond=1, asExternal=True, isAfter2210=False):
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'MCAD')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    unode = node.appendChild(fsXML.createElement('subtract_bodies'))
    if not isAfter2210:
        gnode = unode.appendChild(fsXML.createElement('geometry_name')).appendChild(
            fsXML.createElement('geometry')).appendChild(fsXML.createElement('geometry'))
        gnode.setAttribute('position_in_parent', str(PiPFirst))
        gnode = gnode.appendChild(fsXML.createElement('geometry'))
        gnode.setAttribute('position_in_parent', str(0))
        gnode = unode.appendChild(fsXML.createElement('geometry_name')).appendChild(
            fsXML.createElement('geometry')).appendChild(fsXML.createElement('geometry'))
        gnode.setAttribute('position_in_parent', str(PiPSecond))
        gnode = gnode.appendChild(fsXML.createElement('geometry'))
        gnode.setAttribute('position_in_parent', str(0))


def mcadSingleObject(fsXML, PiP=0, objType='boundingCuboid', asExternal=True, isAfter2210=False):
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'MCAD')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    snode = node.appendChild(fsXML.createElement('single_object'))
    if not isAfter2210:
        gnode = snode.appendChild(fsXML.createElement('geometry_name')).appendChild(
            fsXML.createElement('geometry')).appendChild(fsXML.createElement('geometry'))
        gnode.setAttribute('position_in_parent', str(PiP))
        vnode = snode.appendChild(fsXML.createElement('new_value'))
        vnode.setAttribute('new_value', 'boundingCuboid')
        vnode.setAttribute('property_name', 'type')


def mcadDissect(fsXML, PiP, cubsOnly=True, asExternal=True):
    cubStr = 'true'
    if cubsOnly: cubStr = 'false'
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'MCAD')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    snode = node.appendChild(fsXML.createElement('dissect_body'))
    gnode = snode.appendChild(fsXML.createElement('geometry_name')).appendChild(fsXML.createElement('geometry'))
    gnode.setAttribute('position_in_parent', str(PiP))
    gnode = gnode.appendChild(fsXML.createElement('geometry'))
    gnode.setAttribute('position_in_parent', str(0))
    otypes = ['prismsTets', 'slopingBlocks', 'cylinders']
    for o in otypes:
        gnode = snode.appendChild(fsXML.createElement('new_value'))
        gnode.setAttribute('new_value', cubStr)
        gnode.setAttribute('property_name', o)


def mcadRename(fsXML, partPiP=0, partNm='', bodyNm='', cadNm='', asExternal=True):
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'MCAD')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    snode = node.appendChild(fsXML.createElement('rename'))
    if len(partNm) > 0:
        snode.setAttribute('new_name', partNm)
        gnode = snode.appendChild(fsXML.createElement('geometry_name')).appendChild(
            fsXML.createElement('geometry')).appendChild(fsXML.createElement('geometry'))
        gnode.setAttribute('position_in_parent', str(partPiP))
    if len(bodyNm) > 0:
        snode.setAttribute('new_name', bodyNm)
        gnode = snode.appendChild(fsXML.createElement('geometry_name')).appendChild(
            fsXML.createElement('geometry')).appendChild(fsXML.createElement('geometry'))
        gnode.setAttribute('position_in_parent', str(partPiP))
        gnode = gnode.appendChild(fsXML.createElement('geometry'))
        gnode.setAttribute('position_in_parent', str(0))
    if len(cadNm) > 0:
        snode.setAttribute('new_name', cadNm)
        gnode = snode.appendChild(fsXML.createElement('geometry_name')).appendChild(
            fsXML.createElement('geometry'))


def mcadTransferAssembly(fsXML):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
    node.setAttribute('process', 'MCAD')
    node = node.appendChild(fsXML.createElement('transfer_assembly'))


def edaModifyBoardName(fsXML, nM, asExternal=True):
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'EDA')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    node = node.appendChild(fsXML.createElement('modify_geometry'))
    node.setAttribute('new_value', nM)
    node.setAttribute('property_name', 'Name')
    node.appendChild(fsXML.createElement('geometry_name')).appendChild(fsXML.createElement('geometry'))


def edaSaveAs(fsXML, path, asExternal=True):
    if asExternal:
        node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
        node.setAttribute('process', 'EDA')
    else:
        node = fsXML.getElementsByTagName('xml_log_file')[0]
    node.appendChild(fsXML.createElement('save_as')).setAttribute('filename', path)


def edaQuit(fsXML):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
    node.setAttribute('process', 'EDA')
    node.appendChild(fsXML.createElement('quit'))
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('process_stopped_event'))
    node.setAttribute('process_type', 'EDA')


def mcadQuit(fsXML):
    launch(fsXML=fsXML)
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('external_command'))
    node.setAttribute('process', 'MCAD')
    node.appendChild(fsXML.createElement('quit'))
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('process_stopped_event'))
    node.setAttribute('process_type', 'MCAD')


def modify_model_config(fsXML, new_value, property_name):
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('modify_model_config'))
    node.setAttribute('new_value', new_value)
    node.setAttribute('property_name', property_name)


def modify_transient_solution(fsXML, period_duration, total_end_time, time_unit='s', timePatch=None, saveTimes=None,
                              distIndex=1.5, distType='uniform'):
    # patchStepType: minimumNumber,maximumSize
    # only one dist_type supported
    # timePatch: [[start time, end time,patchStepType, step size/number]]
    if timePatch is None: timePatch = []
    if saveTimes is None: saveTimes = []
    # overall
    node = fsXML.getElementsByTagName('xml_log_file')[0].appendChild(fsXML.createElement('modify_transient_solution'))
    tnode = node.appendChild(fsXML.createElement('overall'))
    tnode.setAttribute('keypoint_tolerance', str(0.0000001))
    tnode.setAttribute('period_duration', str(period_duration))
    tnode.setAttribute('solution_enabled', 'true')
    tnode.setAttribute('time_unit', str(time_unit))
    tnode.setAttribute('total_end_time', str(total_end_time))
    tnode.setAttribute('total_start_time', str(0))

    # time patch
    if len(timePatch) == 0:
        _time_patch(fsXML=fsXML, modNode=node, startTime=0, endTime=total_end_time, stepType='minimumNumber',
                    stepVal=10)
    else:
        for t in timePatch:
            _time_patch(fsXML=fsXML, modNode=node, startTime=t[0], endTime=t[1], stepType=t[2], stepVal=t[3],
                        distIndex=distIndex, distType=distType)

    # save times
    if len(saveTimes) > 0:
        for t in saveTimes:
            node.appendChild(fsXML.createElement('save_time')).setAttribute('save_time_value', str(t))


def _time_patch(fsXML, modNode, startTime, endTime, stepType, stepVal, distType='uniform', distIndex=1.5):
    if stepType == 'maximumSize':
        stepNum = 1000
        stepSz = stepVal
    else:
        stepSz = (endTime - startTime) / 10
        stepNum = stepVal

    tnode = modNode.appendChild(fsXML.createElement('time_patch'))
    sNm = str(startTime) + ' to ' + str(endTime)
    tnode.setAttribute('time_patch_end_time', str(endTime))
    tnode.setAttribute('time_patch_name', sNm)
    tnode.setAttribute('time_patch_start_time', str(startTime))
    tnode.setAttribute('time_patch_step_dist_index', str(distIndex))
    tnode.setAttribute('time_patch_step_dist_type', distType)
    tnode.setAttribute('time_patch_step_size', str(stepSz))
    tnode.setAttribute('time_patch_steps_number', str(stepNum))
    tnode.setAttribute('time_patch_steps_type', stepType)
